#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texCoord;

uniform int WaterYield;
uniform float WaterK[5];
uniform float WaterB[5];
uniform vec4 WaterColor[5];
uniform vec2 WaterSize;
uniform int WaterPipeState;
uniform int blingArea;
uniform sampler2D gold;
uniform vec4 orange;
uniform sampler2D wink;
uniform float fade[1];
uniform sampler2D sand;




int getYArea()
{
	vec2 pos = vec2(v_texCoord.x, 1.0 - v_texCoord.y);	
	for(int i = 4; i >= 0; i--)
	{
		if(WaterPipeState == 2 && WaterYield - 1 == i)
		{
			if(pos.y*WaterSize.y > sin(0.02*pos.x*WaterSize.x)*5.0 + WaterB[i] + sin(0.08*pos.x*WaterSize.x)*5.0)
			{
				return i + 1;
			}
		}
		else
		{
			if(pos.y*WaterSize.y > WaterK[i]*pos.x*WaterSize.x + WaterB[i])
			{
				return i + 1;
			}
		}
	}
	return 0;
	
}

vec4 getColor()
{
	if(WaterYield == 0)
	{
		return vec4(0.0);
	}
	
	int index = getYArea();
	if(index >= WaterYield)
	{
		return vec4(0.0);
	}
	else if(index >= WaterYield - blingArea && WaterColor[index] != orange)
	{
		return WaterColor[index] * fade[0];
	}
	else
	{
		if(texture2D(sand, v_texCoord).a > 0.01 && WaterColor[index] != orange)
		{
			return WaterColor[index] - vec4(vec3(0.08), 0.0);
		}
		else
		{
			return WaterColor[index];
		}
	}
	
}

 
void main(void)
{
	vec4 color = texture2D(CC_Texture0, v_texCoord);
	if(color.a <= 0.05)
	{
		gl_FragColor = vec4(0.0);
	}
	else
	{
		gl_FragColor = getColor();
		if(gl_FragColor == orange)
		{
			gl_FragColor = texture2D(wink, v_texCoord) + texture2D(gold, v_texCoord);
		}
	}
}
